#!/usr/bin/perl

use warnings;

open(SM, "< translat.TXT") or die "can't find translat.TXT file";

$index = 0;

while(<SM>)
{
        s/\015?\012//;          #removing windows newline shit

        if(/^\*{21}/)           #jumping to next record when 21 asterisks
        {
                $index++;
        }
        elsif (/^\*.*Text/)     #flagging Text part (english)
        {
                $text = 1;
        }
        elsif (/^\*.*Transl/)   #flagging Translation part (polish)
        {
                $text = 0;
        }
        else                    #reading text or translation
        {
                if($text)
                {
                        $texts[$index] = $_;
                }
                else
                {
                        $transl[$index] .= "$_\n";	#may be multilined
                }
	}
}
close (SM);
open (SM,"< Q&A_ADVANCED ENGLISH.TXT") or die "can't find Q&A_ADVANCED ENGLISH.TXT file";

while (<SM>)
{
        s/\015?\012//;                  #removing windows newline shit

        if (/^(A: )(.*)/)               #getting answer (may be multiline)
        {
                $a .= $2;
        }
        elsif (/^(S: ).*?(\d+)\.wav/)   #question sound filename, answer sound filename is 1 higher
        {
                $words[$2+1] = $a;
                $a='';
        }
}
close(SM);

$now = 1;
$output = '';

for ($i=0 ; $i<$#words ; $i++) 			#now we are looking for translations
{
	print "converting entry nr $now \r";
	next unless $words[$i];
	
	for ($j=0 ; $j<$#texts ; $j++)
	{
		next unless $texts[$j];	
		if($words[$i] eq $texts[$j])
		{
			$output .= "<q>$transl[$j]</q>\n<a>$words[$i]<snd>smsnds/$i.wav</snd></a>\n\n";
			undef $texts[$j];				#removing already found entry	
			$words[$i] = "ok";				#flagging files not to remove	
			$now++;
			last;	
		}
	}
}
open (FR, "> sm2fr.txt");
print FR $output;
close(FR);

#making list of needed files

open (FILE, "> files.txt");

for($i=0 ; $i<$#words ; $i++)
{
	next unless $words[$i];
	if($words[$i] eq "ok")
	{
		print FILE "$i.wav\n";
	}

}
close (FILE);


